

%% This makes the Plots

% If needed, load time series (check sample)

% LT fcsts

pth = pwd;
ind = strfind(pth,'Code');
datapath1 = [pth(1,1:ind-1),'Data'];
if isunix, pathslash = '/'; else pathslash = '\'; end

load([datapath1, pathslash, 'LTFCST']);

%load LTFCST

% % Median exogenous drift
% 
% load RE_510Ymedian
% 
% % Median constant gain
% 
% load CG_510Ymedian 
% 
%  
 sampleLT = Obs_start:1/4:Obs_end;
 

% Dates setup


samplest = EstsamplestB + size(Y_data_iniB,2)/4:1/4:EstsamplendB;


iniplot  = 1960;

samplot = iniplot:1/4:EstsamplendB;

samplotindex = find(samplest >= iniplot);

samplestfe = EstsamplestB + 1/4 + size(Y_data_iniB,2)/4:1/4:EstsamplendB;

samplotindexfe = find(samplestfe >= iniplot);

samplotindexLTfcsts = find(sampleLT >= iniplot & sampleLT <=samplot(end));


% Observed forecast errors (1Q ahead)

fcterr_obs = Y_obsB(vrbs_obsB.infl,2:end)'-Y_obsB(vrbs_obsB.infl1Q_spf,1:end-1)';


%% Figure 1: short-term forecasts

fg1 = figure('visible','off');

plot(samplot,ypredBmode(vrbs_obsB.infl,samplotindex),'k--','Color',[0.49 0.49 0.49])

hold on

plot(samplot,Y_obsB(vrbs_obsB.infl1Q_spf,samplotindex)','b-','LineWidth',2)
plot(samplot,Y_obsB(vrbs_obsB.infl2Q_spf,samplotindex)','r-','LineWidth',2)
plot(samplot,Y_obsB(vrbs_obsB.infl12Q_liv,samplotindex)','bo','LineWidth',1)
plot(samplot,Y_obsB(vrbs_obsB.infl12Q_livtrue,samplotindex)','ro','LineWidth',1)

hold off

  legend('CPI','SPF1Q','SPF2Q','LIV1','LIV2','Location','Best');

  xlim([samplot(1),samplot(end)])
  ylim([-2.0;20])
  
 ng = 'US_STforecasts';  
 
 
    namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);
 

 
 %       print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');

 
 
%% Figure 2: short-term forecast errors 

fg2 = figure('visible','off');

 %[h1] =  vcPlotDistBands(ypredB_fcsterrors(samplotindexfe,:)',samplot)
 vcPlotDistBands(ypredB_fcsterrors(samplotindexfe,:)',samplot);



 h2 = plot(samplot,...
    fcterr_obs(samplotindexfe),...
    'r-','LineWidth',1);

% hold on
% 
%  h3 = plot(samplot,...
%     ypredB_fcsterrorsmode(samplotindexfe),...
%     'b-','LineWidth',1);
% 
% hold off

 
 xlim([samplot(2),samplot(end)])
ylim([-6,6])

ng = 'US_forecast_errors';  

namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);
 

%       print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');
% 
% 
% 



 %% Figure 3: long-term inflation forecast 

 
fg3 = figure('visible','off');

 %h1 =  vcPlotDistBands(squeeze(ypredB_mat(vrbs_obsB.infl510Y_bcff(1),samplotindex,:))',samplot);
 vcPlotDistBands(squeeze(ypredB_mat(vrbs_obsB.infl510Y_bcff(1),samplotindex,:))',samplot);

 
 %h1b = plot(samplot,ypredBmode(vrbs_obsB.infl510Y_bcff(1),samplotindex,:),'b-','LineWidth',1);
 
xlim([samplot(1),samplot(end)])

ylim([-0.01,10])
 
 
 %pause
 
 
 % h1c = plot(samplot,pistar_mode(samplotindex),'b--','LineWidth',1);

 
  ng = 'US_LTforecasts1';  

  namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);
  
  
  %        print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');

 
 
 % Michigan Survey (5-10)
 h2 = plot(samplot,LTvars(samplotindexLTfcsts,8),'rd','LineWidth',1.0);
 
%pause

  ng = 'US_LTforecasts2';  
  
  namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);
  
  
%        print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');

       
 
 % Decision-Makers Poll
 h3 = plot(samplot,LTvars(samplotindexLTfcsts,9),'go','LineWidth',1.0);
 
 
%pause


  ng = 'US_LTforecasts3';  
  
  namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);
  
  
  
%        print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');


 % Blue Chip Economics 1-10Y
 
 h4 = plot(samplot,LTvars(samplotindexLTfcsts,3),'bs','LineWidth',1.0);
 
 
%pause

  ng = 'US_LTforecasts4';  
  
  namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);
%        print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');


 % Blue Chip Economics 5-10Y  
 h5 = plot(samplot,LTvars(samplotindexLTfcsts,6),'gd','LineWidth',1.0);
 
 ng = 'US_LTforecasts5';  
  
  namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);
%pause

%  Blue Chip Financial 5-10Y  
 h6 = plot(samplot,LTvars(samplotindexLTfcsts,5),'ro','LineWidth',1.0);

 
%pause

ng = 'US_LTforecasts6';  
  
  namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);


% %  % SPF 1-10yrs
% %  
% %  h7 = plot(samplot,LTvars(samplotindexLTfcsts,4),'gs');
% %  
% % pause
% 
%  ng = 'US_LTforecasts5';  
%        print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');
% 
% 
% 
 % Consensus economics 5-10Y
 
h8a = plot(samplot,LTvars(samplotindexLTfcsts,7),'r*','LineWidth',1.0);
 
%pause
ng = 'US_LTforecasts7';  
  
  namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]); 
% ng = 'US_LTforecasts6';  
%        print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');


% SPF 5-10Y
 
h8 = plot(samplot,LTvars(samplotindexLTfcsts,1),'b*','LineWidth',1.0);


ng = 'US_LTforecasts8';  
  
  namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);
    
    
    
    
%  ng = 'US_LTforecasts7';  
%        print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');



% 
%  %% Figure 4: long-term inflation forecast, models' comparison, fixed pistar 
% 
%  
% figure(4)
% 
%  %h1 =  vcPlotDistBands(squeeze(ypredB_mat(vrbs_obsB.infl510Y_bcff(1),samplotindex,:))',samplot);
%  vcPlotDistBands(squeeze(ypredB_mat(vrbs_obsB.infl510Y_bcff(1),samplotindex,:))',samplot);
% 
%  xlim([samplot(1),samplot(end)])
% ylim([-0.01,10])
% 
%  %h1b = plot(samplot,ypredBmode(vrbs_obsB.infl510Y_bcff(1),samplotindex,:),'b-','LineWidth',1);
%  
%  
%  % ng = 'US_LTforecasts1';  
%  %       print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');
% 
%  
%  
%  % Michigan Survey (5-10)
%  h2 = plot(samplot,LTvars(samplotindexLTfcsts,8),'rd');
%  
%  
%  % Decision-Makers Poll
%  h3 = plot(samplot,LTvars(samplotindexLTfcsts,9),'ro');
%  
%  
% 
%  % Blue Chip Economics 1-10Y
%  
%  h4 = plot(samplot,LTvars(samplotindexLTfcsts,3),'rs');
%  
%  
% 
% 
%  % Blue Chip Economics 5-10Y  
%  h5 = plot(samplot,LTvars(samplotindexLTfcsts,6),'rd');
%  
%  
% pause
% 
%  % Blue Chip Financial 5-10Y  
% %  h6 = plot(samplot,LTvars(samplotindexLTfcsts,5),'ro');
% % 
% %  
% % pause
% 
% 
% %  % SPF 1-10yrs
% %  
% %  h7 = plot(samplot,LTvars(samplotindexLTfcsts,4),'gs');
% %  
% % pause
% 
% 
%  % Consensus economics 5-10Y
%  
% % h8 = plot(samplot,LTvars(samplotindexLTfcsts,7),'c*');
% %  
% % pause
% %  
% % 
% % 
% % % SPF 5-10Y
% %  
% % h8 = plot(samplot,LTvars(samplotindexLTfcsts,1),'b*');
% 
% 
% 
% 
% 
% % Median exogenous drift
% 
% h9 = plot(samplot,re510mediam,'b-','lineWidth',2);
% 
% 
% 
% 
% pause
% 
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  %% Figure 5: long-term inflation forecast, models' comparison, fixed pistar 
% 
%  
% figure(5)
% 
%  %h1 =  vcPlotDistBands(squeeze(ypredB_mat(vrbs_obsB.infl510Y_bcff(1),samplotindex,:))',samplot);
%  vcPlotDistBands(squeeze(ypredB_mat(vrbs_obsB.infl510Y_bcff(1),samplotindex,:))',samplot);
% 
%  xlim([samplot(1),samplot(end)])
% ylim([-0.01,10])
% 
%  %h1b = plot(samplot,ypredBmode(vrbs_obsB.infl510Y_bcff(1),samplotindex,:),'b-','LineWidth',1);
%  
%  
%  % ng = 'US_LTforecasts1';  
%  %       print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');
% 
%  
%  
%  % Michigan Survey (5-10)
%  h2 = plot(samplot,LTvars(samplotindexLTfcsts,8),'rd');
%  
%  
%  % Decision-Makers Poll
%  h3 = plot(samplot,LTvars(samplotindexLTfcsts,9),'ro');
%  
%  
% 
%  % Blue Chip Economics 1-10Y
%  
%  h4 = plot(samplot,LTvars(samplotindexLTfcsts,3),'rs');
%  
%  
% 
% 
%  % Blue Chip Economics 5-10Y  
%  h5 = plot(samplot,LTvars(samplotindexLTfcsts,6),'rd');
%  
%  
% 
%  % Blue Chip Financial 5-10Y  
% %  h6 = plot(samplot,LTvars(samplotindexLTfcsts,5),'ro');
% % 
% %  
% % pause
% 
% 
% %  % SPF 1-10yrs
% %  
% %  h7 = plot(samplot,LTvars(samplotindexLTfcsts,4),'gs');
% %  
% % pause
% 
% 
%  % Consensus economics 5-10Y
%  
% % h8 = plot(samplot,LTvars(samplotindexLTfcsts,7),'c*');
% %  
% % pause
% %  
% % 
% % 
% % % SPF 5-10Y
% %  
% % h8 = plot(samplot,LTvars(samplotindexLTfcsts,1),'b*');
% 
% 
% 
% pause
% 
% % Median constant gain
% 
% h10 = plot(samplot,cg510mediam,'b-','lineWidth',2);
% 
% 

%pause









%% Figure 6: learning gain 

fg4 = figure('visible','off');


subplot(2,1,1)

  vcPlotDistBands(squeeze(ypredB_mat(vrbs_obsB.infl510Y_bcff(1),samplotindex,:))',samplot);

 
 
 %h1b = plot(samplot,ypredBmode(vrbs_obsB.infl510Y_bcff,samplotindex,:),'k-','LineWidth',1);
 
xlim([samplot(1),samplot(end)])
ylim([0,10])

subplot(2,1,2)


 vcPlotDistBands(constant_gain(samplotindex,:)',samplot);
 
 
 %h1b = plot(samplot,gain_mode(samplotindex,:),'k-','LineWidth',1);
 
 
 
 
 xlim([samplot(1),samplot(end)])

 ng = 'US_gain';  

 namesinglefig_eps = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.eps'))];
    
    namesinglefig_pdf = [REStimedetails([1:2 4:6 8:11]),cmts,char(strcat(ng,'.pdf'))];
    
    
    print(gcf, '-dpsc', '-r300', [FigPredpath,'\',namesinglefig_eps]);
    
    print(gcf, '-dpdf', '-r300', [FigPredpath,'\',namesinglefig_pdf]);

return

%        print(char(strcat(ng,'.eps')),'-depsc2');   print(char(strcat(ng,'.pdf')),'-dpdf');

 
%  % Save median
%  
%  XV = squeeze(ypredB_mat(vrbs_obsB.infl510Y_bcff(1),samplotindex,:))';
%  
%  B510mediam = prctile(XV,50);
%  
%  save B_510Ymedian B510mediam
 
 