function [X_draws,xi_TT_matCk,ypred_matCk,Logpost_draw,accept,accept_var,p_acc,p_acc_var] = ...
                    Gibbs_draw2(sigscale,x,csquare,MH_select,CF_select,...
                    Mspec,priors,PriorsCF,params,params_index,params_estimated_index,...
                    bounds,trspec,vrbs,vrbs_obs,shocks,shocks_oe,ModelDim,Sml, type,learning,Y_main,Y_pre,trainingSampleLength)
         

%% Main Gibbs

 
 % State Space
params(params_estimated_index) = x; npara = length(x(MH_select));
X_draws = x;
 
KFold = Obj_fun_postMH(x,priors,0,Mspec,params,params_index,params_estimated_index,...
                                      trspec,vrbs,vrbs_obs,shocks,shocks_oe,ModelDim,Sml,type,learning,Y_main,Y_pre,trainingSampleLength);
logpost_old = KFold.OBJ;
xi_0 = KFold.xi_0; P_0 = KFold.P_0; sel_stat = KFold.sel_stat;
P0sr_stat_old = KFold.P0sr_stat_mew;
  
                                  
T = size(Y_main,1);

% Insert x0 in th inputs here
% MH Step                                  
outside_bounds = 1;
      
   while outside_bounds                                 


 X_draws(MH_select) = x(MH_select) + csquare*(sigscale*randn(npara,1));  
 % X_draws(MH_select) = Xoptdraw + csquare*(sigscale*randn(npara,1));  
  
%  keyboard
    % parameters' bounds
boundsflag = sum(X_draws > bounds(params_estimated_index,2)) + ...
             sum(X_draws < bounds(params_estimated_index,1));
          
% Computes posterior
if boundsflag == 0
KFnew = Obj_fun_postMH(X_draws,priors,0,Mspec,params,params_index,params_estimated_index,...
                                      trspec,vrbs,vrbs_obs,shocks,shocks_oe,ModelDim,Sml,type,learning,Y_main,Y_pre,trainingSampleLength);
logpost_new = KFnew.OBJ;
P0sr_stat_new = KFnew.P0sr_stat_mew; 

else       
 logpost_new = -10e20;    
end 


% Check boundaries                                   
  if logpost_new > -10e10 && boundsflag == 0          
            outside_bounds = 0;      
  else          
            outside_bounds = 1;
  end

   end %while loop
  
p_acc = min(1,exp(logpost_new-logpost_old));
accept = binornd(1,p_acc); 

    if ~accept        
     X_draws(MH_select) = x(MH_select);  
     Logpost_draw = logpost_old;
     KF = KFold;
     
    else
     Logpost_draw = logpost_new;
     P0sr_stat_old = P0sr_stat_new;
     KF = KFnew;
    end

% Smoother
[xi_TT_matCk,xiS_0,ypred_matCk] = CarterKohnvLW(Mspec,params,params_index,params_estimated_index,vrbs,vrbs_obs,shocks,shocks_oe,ModelDim,type,learning,Sml,Y_main,trainingSampleLength,X_draws,KF);

 xtdraw = [xiS_0(vrbs.x); xi_TT_matCk(vrbs.x,:)'];
 xtdrawL = [xiS_0(vrbs.x_L); xi_TT_matCk(vrbs.x_L,:)'];
 
 mutdraw = [xiS_0(vrbs.mu);xi_TT_matCk(vrbs.mu,:)'];
 
 S = (xtdraw(2:end) - X_draws(1)*xtdraw(1:end-1)- X_draws(2)*xtdrawL(1:end-1))'*...
     (xtdraw(2:end) - X_draws(1)*xtdraw(1:end-1)- X_draws(2)*xtdrawL(1:end-1)) + PriorsCF.Psix;  
 sig_x = iwishrnd(S,PriorsCF.df_x + T);
 
 S = (mutdraw(2:end) - X_draws(6)*mutdraw(1:end-1))'*(mutdraw(2:end) - X_draws(6)*mutdraw(1:end-1)) + PriorsCF.Psimu;  

 sig_mu = iwishrnd(S,PriorsCF.df_mu + T);
 
 S = diff(xi_TT_matCk(vrbs.pistar,:)')'*diff(xi_TT_matCk(vrbs.pistar,:)') + PriorsCF.SC0pist;
 sig_pist = iwishrnd(S,PriorsCF.df0pist + T);
 
 

% Selected params
   std_vec = sqrt([sig_x, sig_mu, sig_pist]);
  X_draws(CF_select) = std_vec;
 
 % disp(X_draws(CF_select))
%  p_acc_var = 1;
%  accept_var = 1;


% compute P0sr_stat_new

params(params_estimated_index) = X_draws;
[F,~,Q] = eval(['add_to_StateSpace',Mspec,'(vrbs,params,params_index,ModelDim.nvar,ModelDim.nshock,ModelDim.noe,shocks,learning,Sml)']);


Q_sr_stat = Q(sel_stat,sel_stat);
 ns = length(sel_stat); 
vecP0_sr_stat = (eye(ns^2)-kron(F(sel_stat,sel_stat),...
                  F(sel_stat,sel_stat)))\Q_sr_stat(:);

P0sr_stat = reshape(vecP0_sr_stat,ns,ns);
P0sr_stat_new = (P0sr_stat + P0sr_stat')/2;
                              
 
 if ~isnan(P0sr_stat_new)

    rat = mvnpdf(xiS_0(sel_stat(2:3)), xi_0(sel_stat(2:3)), P0sr_stat_new(2:3,2:3))...
        / mvnpdf(xiS_0(sel_stat(2:3)), xi_0(sel_stat(2:3),1), P0sr_stat_old(2:3,2:3));
   
  p_acc_var = min(rat,1);
  accept_var = binornd(1,p_acc_var); 
  
  if ~accept_var        
      X_draws(CF_select) = x(CF_select);  
   end
  
  else
     p_acc_var = 0;accept_var=0;
    X_draws(CF_select) = x(CF_select); 
 end  
%  disp('here')
%  disp(X_draws)
