

%% Initialization
MIN = 1;
sigscale = sigscale_fun(priors);

% Csminwel setup
size_vector = 1e-4.*ones(length(params_estimated),1);
GMat = diag(size_vector);
csmwmaxeval = 20;

% Fminsearch setup
stop_crit_x = 1e-8; stop_crit_f = 1e-8; maxits = 200;
max_funevals = 1.5*maxits;

% initialize empty results matrices
fval_v = NaN(n_ests,1);
opt_x_v = NaN(length(params_estimated),n_ests);

sampleSize=size(Y_main,1);


if use_previous
 load([spath,...
    'Mode',pathslash,...
    previous_estimate_name],'xmode','Logpostmode');
    xmode1 = xmode;
    params_estimated_ini=[xmode1(1:end-2);xmode1(end-1) ;0.05;xmode1(end)];%[xmode1(1:end-2);0.1;xmode1(end-1) ;0.1;xmode1(end)];
    
    disp(['starting with intial values from:',previous_estimate_name])
    disp(['Logpostmode =',num2str(Logpostmode)]) 
    if length(params_estimated_ini) ~= length(params_estimated_index)
        disp('It is not possible to use these estimates! wrong number of parameters')
        return
    end
    
else
params_estimated_ini = params_estimated;
end


params(params_estimated_index) = params_estimated_ini;
        
% [~,~,~,~,~,~,flag_solve] = solveModelv1(Mspec,params,params_index,vrbs,shocks,ModelDim,type,learning,Sml);
% 
%                      
% if flag_solve 
%     
%     disp('parameters inconsistent with constraints'); return
%     
% end


for est = 1:n_ests
    % Set random initial parameters (x0)
    if est >= 1 && iter ~= 1 && randomize
        
        
        bounds_flag = 1;
        
        while bounds_flag > 0
     %   x0_ini = x0_start + 0.2*diag(sigscale).*randn(length(x0),1); % randomize around previous peak

        params_estimated_ini = params_estimated + 0.12*(diag(sigscale).*randn(length(params_estimated),1)); % randomize around previous peak

                
        % First, reset params
        params(params_estimated_index) = params_estimated_ini;
        
        % Second, bounds on parameter values
        
        bounds_flag_params = sum(params(params_estimated_index) > bounds(params_estimated_index,2)) + sum(params(params_estimated_index) < bounds(params_estimated_index,1));

        
        if bounds_flag_params > 0
            
         bounds_flag = bounds_flag_params;
         
        else
        
        x0_ini = invtrans(params_estimated_ini,trspec(params_estimated_index,:)); % tranform parameters

      
        
        [OBJ_Test] = Obj_fun_post(x0_ini,priors,MIN,Mspec,params,params_index,params_estimated_index,...
                                      trspec,vrbs,vrbs_obs,shocks,shocks_oe,ModelDim,Sml, type,learning,Y_main,Y_pre,trainingSampleLength);
         
           OBJ_Testlim = 15000000000000;
           bounds_flag = (OBJ_Test > OBJ_Testlim);
           
%          if OBJ_Test > 10e10
%               
%               bounds_flag = 1;
%           else
%               
%               bounds_flag =0;
%           
%           end    
          
        end % bounds_flag_params loop
        
    end  % while loop
      
    else
     
    
    x0_ini = invtrans(params_estimated_ini,trspec(params_estimated_index,:)); % tranform parameters    
    
    end % randomize loop
    
    
    
    % after you get an initial condition consistet with bounds
    
 

  x0 = x0_ini;
  
  
      
    done = 0; round = 0;
    
    
     while done ~= 1 && round < 3 
         
         round = round +1; 
   
         %for round = 1:n_rounds
        
        disp('Estimation Number:'); disp(est);
        disp('Optimization Number:'); disp(round);
        
        
        % set up options
        if ismember(round, [6 7])
            options = optimset('Display','iter','TolX',stop_crit_x,'TolFun',stop_crit_f,'MaxFunEvals',max_funevals,'MaxIter',5000);
        elseif ismember(round, [8 9 10])
            options = optimset('Display','iter','TolX',stop_crit_x,'TolFun',stop_crit_f,'MaxFunEvals',max_funevals,'MaxIter',10000);
        else
            options = optimset('Display','iter','TolX',stop_crit_x,'TolFun',stop_crit_f,'MaxFunEvals',max_funevals,'MaxIter',maxits);
        end
        
        
        % For testing
        
%          [opt_x1,fval,exitflag,output] = fminunc('Obj_fun_post',x0,options,priors,MIN,params,params_index,params_estimated_index,...
%                                       trspec,vrbs,vrbs_obs,shocks,shocks_oe, ModelDim,Sml,type,...
%                                       learning,Y_main,Y_pre,trainingSampleLength);
        
        % if case 4, recompute x0.
        if round == 2
           % try
%                 [opt_x1,fval,exitflag,output] = fminunc('Obj_fun_post',x0,options,priors,MIN,Mspec,params,params_index,params_estimated_index,...
%                                       trspec,vrbs,vrbs_obs,shocks,shocks_oe, ModelDim,Sml,type,...
%                                       learning,Y_main,Y_pre,trainingSampleLength);
%                 x0 = opt_x1;
                
           % catch ME
            %end
        end
        
%         if round ==2 %|| round < 15
%             try
%                 [fval,opt_x1,gh,H,itct,fcount,retcodeh] = csminwel('Obj_fun_post',x0,GMat,[],1e-8,csmwmaxeval,priors,MIN,...
%                                       Mspec,params,params_index,params_estimated_index,...
%                                       trspec,vrbs,vrbs_obs,shocks,shocks_oe, ModelDim,Sml,type,...
%                                       learning,Y_main,Y_pre,trainingSampleLength);
%                    if fval < 100000
%                        
%                 x0 = opt_x1;
%                 
%                    end
%                 
%                 if fval < 100000 && itct < csmwmaxeval;
%                     
%                     done = 1;
%                     
%                 end
%                 
%             catch ME
%                 
%             end
%         end
        %end
        
        if round == 1 || round == 3
        % optimize
        %if round > 1
        %try
        [opt_x,fval,exitflagfs,output] = fminsearch('Obj_fun_post',x0,options,priors,MIN,Mspec,params,params_index,params_estimated_index,...
                                      trspec,vrbs,vrbs_obs,shocks,shocks_oe, ModelDim,Sml,type,...
                                      learning,Y_main,Y_pre,trainingSampleLength);
%         x0 = opt_x; done = exitflagfs;
        
        %catch ME
            
       % end
        
        end
        
        
    end
    
    %% save optimal mode and optmized value
    opt_x_v(:,est) = x0;
    fval_v(est) = fval;
    
end

% Select Mode

[~, bs] = min(fval_v);

Logpostmode = -fval_v(bs);
xmode = trans(opt_x_v(:,bs),trspec(params_estimated_index,:));

%% Save Mode
% save([spath,...
%     'Mode',pathslash,...
%     [timestamp, EstimationName]],'fval_v','opt_x_v','priors','xmode','Logpostmode','params',...
%                                'params_index','params_estimated_index','-append');




