
function [xi_TT_matCk,xiS_0,ypred_matCk] = CarterKohnvLW(Mspec,params,params_index,params_estimated_index,vrbs,vrbs_obs,shocks,shocks_oe,ModelDim,type,learning,Sml,Y_main,trainingSampleLength,X_select_draws,KF)
%% Computes draws from parameter and states

xi_0 = KF.xi_0;
P_0 = KF.P_0;
F = KF.F;
Q = KF.Q;
H = KF.H;
M = KF.M;
xi_tt_mat = KF.xi_tt_mat;
Ptt_mat = KF.Ptt_mat;

 % Define matrices

 %totalvars = ModelDim.nvar + ModelDim.noe + ModelDim.nshock;
% totalvars = ModelDim.nvar + ModelDim.nshock; % Laubach2
 
xi_TT_matCk = NaN(ModelDim.nvar,size(Y_main,1));

ypred_matCk = NaN(ModelDim.nobs,size(Y_main,1));


%for Ck = 1:size(X_select_draws,2)
    
   % disp(Ck);
%   params(params_estimated_index) = X_select_draws;
    
%     [~,xi_tt_mat,Ptt_mat,~,~,F_til,Q_til,Hm_til,M,~] = KalmanFilter(Mspec,params,params_index,vrbs,vrbs_obs,shocks,shocks_oe,ModelDim,type,learning,Sml,Y_main,trainingSampleLength);

    xi_TT = xi_tt_mat(:,end);
    
    P_TT = Ptt_mat(:,:,end);  
    

     % Draw from N(F_TT,P_TT)
   % xi_TT_draw = mvnrnd(xi_TT,P_TT);
   
[U,D,V] = svd(P_TT);

xi_TT_draw = xi_TT + U*sqrt(D)*V'*randn(size(F,2),1);
    
% Draw from p(F_T|Y_T,params) according to Carter and Kohn('94)
    % Iterate backwards to obtain F_tt and P_tt for t = T-1 to 1, save F's
    % and P's for all steps, then draw from these to obtain F_t's.
    
    
%     xi_t = zeros(k,T);
xi_t = NaN(size(xi_tt_mat));
    
    xi_t(:,end) = xi_TT_draw;
    
    for t = size(xi_tt_mat,2)-1:-1:1
        
        xi_tt = xi_tt_mat(:,t);
        
        P_tt = Ptt_mat(:,:,t);
        
        % Compute inverse using singular value decomposition
        
        %%%%%%%%
        
    P_star = F*P_tt*F' + Q;    
        
    [u,s,v] = svd(P_star);

    md = min(size(s));
    bigev = find(diag(s(1:md,1:md))>1e-6);
    sigpropdim = length(bigev);


for i = 1:md
    if i > sigpropdim
        s(i,i) = 0;
    else
        s(i,i)    = 1/s(i,i);
    end
end

    P_star_inv = v*s*u';

    
    %%%%%%%
        
        
        xi_ttxitplus1 = xi_tt + P_tt*F'*P_star_inv*(xi_t(:,t+1) - F*xi_tt);     
        
        P_ttPtplus1 = P_tt - P_tt*F'*P_star_inv*F*P_tt;     
        
        
        [U2,D2,V2] = svd(P_ttPtplus1);

         xi_t(:,t) = (xi_ttxitplus1 + U2*sqrt(D2)*V2'*randn(size(F,2),1));
        
        
    end;
    
    % initial condition
    
     P_star = F*P_0*F' + Q;    
        
    [u,s,v] = svd(P_star);

    md = min(size(s));
    bigev = find(diag(s(1:md,1:md))>1e-6);
    sigpropdim = length(bigev);


for i = 1:md
    if i > sigpropdim
        s(i,i) = 0;
    else
        s(i,i)    = 1/s(i,i);
    end
end

    P_star_inv = v*s*u';

    
    %%%%%%%
        
    %    P_star_inv = pinv(F_til*P_tt*F_til' + Q_til); %CHANGE THIS!!
        
        xi_ttxitplus1 = xi_0 + P_0*F'*P_star_inv*(xi_t(:,t) - F*xi_0);     
        
        P_ttPtplus1 = P_0 - P_0*F'*P_star_inv*F*P_0;     
        
        %xi_t(:,t) = mvnrnd(xi_ttxitplus1,P_ttPtplus1)';
        
        [U2,D2,V2] = svd(P_ttPtplus1);

         xiS_0 = (xi_ttxitplus1 + U2*sqrt(D2)*V2'*randn(size(F,2),1));
        

    
    
    xi_TT_matCk(:,:) = xi_t;  
    
   
    M_mat =  repmat(M.M0,1,size(xi_tt_mat,2));

    %ypred_matCk(:,:,Ck) = M_mat + Hm_til'*xi_t;
    %ypred_matCk = M_mat + M.Mu*Y_main(:,end)' + H'*xi_t;
    ypred_matCk = M_mat + H'*xi_t;

%end % end Ck