function [vrbs, shocks,shocks_oe,ModelDim] = defineVariablesLaubach()
% This function outputs the following:
% vrbs: a structure containing the position of all variables (with jump
% variables ordered before state variables)
% nvar: the total number of variables (size of vrbs)
% nstate: the number of state variables

% variables
vrbs.x       = 1;   
vrbs.x_L1    = 2; 
vrbs.x_L2    = 3;
vrbs.pi      = 4;
vrbs.pi_L1    = 5;
vrbs.pi_L2    = 6;
vrbs.pi_L3    = 7;
vrbs.ustar   = 8;
vrbs.g       = 9;
vrbs.s       = 10;
vrbs.f       = 11;
vrbs.chi     = 12;
vrbs.utrend  = 13;

ModelDim.nvar = 13;


% Observation shocks
%vrbs.oe_wage   = nlags + 1;  type.oe_wage   = 'oe state';         

    
% shocks
shocks.sig_x = 1;
shocks.sig_pi = 2;
shocks.sig_ustar = 3;
shocks.sig_g = 4;
shocks.sig_s = 5;
shocks.sig_f = 6;
shocks.sig_chi = 7;

ModelDim.nshock = 7;


% observation shocks
%shocks_oe.wage = ModelDim.nshock + 1;
shocks_oe.oe = NaN;

ModelDim.noe = 0;


end

