

function [Y_main,Y_main_all,vrbs_obs,nobs,trainingSampleLength,Y_pre,startSample,endSample] = getDataNocapital()


%% Loads and prepared data

% get indices for observables
[vrbs_obs,nobs] = defineObservables();


load DataMat_interactions

Y_main_all = [interactions_dataset.output_growth./4 interactions_dataset.inflation./4 ...
          interactions_dataset.rwage_growth interactions_dataset.Tbill./4 ...
          interactions_dataset.tax_output_ratio interactions_dataset.debt_GDP_ratio_sample ...
          interactions_dataset.exp_infl1Q./4 interactions_dataset.exp_infl4Q./4 ...
          interactions_dataset.exp_Tbill1Q./4 interactions_dataset.exp_Tbill4Q./4 ...
          interactions_dataset.exp_infl510./4 interactions_dataset.exp_Tbill510./4 ...
          interactions_dataset.outputgap];
      
% Select variables to be used in estimation      
Y_main = Y_main_all;
% Y_main(:,[vrbs_obs.Tax,vrbs_obs.GDebt,vrbs_obs.exp_infl1Q,vrbs_obs.exp_infl4Q,...
%           vrbs_obs.exp_Tbill1Q, vrbs_obs.exp_Tbill4Q, vrbs_obs.exp_Tbill510,vrbs_obs.outputgap]) = NaN;     

% Out wages...
% Y_main(:,[vrbs_obs.Wage, vrbs_obs.Tax,vrbs_obs.GDebt,vrbs_obs.exp_infl4Q,...
%           vrbs_obs.exp_Tbill1Q, vrbs_obs.exp_Tbill4Q, vrbs_obs.exp_Tbill510,vrbs_obs.outputgap]) = NaN;           

%Out wages; output growth...in output gap
% Y_main(:,[vrbs_obs.GDP, vrbs_obs.Wage, vrbs_obs.Tax,vrbs_obs.GDebt,vrbs_obs.exp_infl4Q,...
%           vrbs_obs.exp_Tbill1Q, vrbs_obs.exp_Tbill4Q, vrbs_obs.exp_Tbill510]) = NaN;           
      
% % Out output growth...in output gap
% Y_main(:,[vrbs_obs.GDP,  vrbs_obs.Tax,vrbs_obs.GDebt,vrbs_obs.exp_infl4Q,...
%           vrbs_obs.exp_Tbill1Q, vrbs_obs.exp_Tbill4Q, vrbs_obs.exp_Tbill510]) = NaN;

% % Out output growth...in output gap
Y_main(:,[vrbs_obs.GDP,  vrbs_obs.Tax,vrbs_obs.GDebt,vrbs_obs.exp_infl4Q,...
           vrbs_obs.exp_Tbill4Q]) = NaN;

% Out output growth...in output gap and debt
% Y_main(:,[vrbs_obs.GDP, vrbs_obs.Wage,  vrbs_obs.Tax,vrbs_obs.exp_infl4Q,...
%            vrbs_obs.exp_Tbill4Q]) = NaN;

% Out gap, in output growth
% Y_main(:,[vrbs_obs.Tax,vrbs_obs.exp_infl4Q,...
%            vrbs_obs.exp_Tbill4Q,vrbs_obs.outputgap]) = NaN;

% Out gap, in wage out
% Y_main(:,[vrbs_obs.GDP,  vrbs_obs.Tax,vrbs_obs.exp_infl4Q,...
%            vrbs_obs.exp_Tbill4Q]) = NaN;



%  trainingSampleLength = 4*5;
%  Y_pre = 0;
%  startSample = 1955; %% NOTE: this the sample with load here
%  endSample = 2007.5;     
%  
 
 % Restrict Sample
 
 samplecount = 1955:1/4:2007.5;
 
 %sampos = find(samplecount >= 1980);
 sampos = find(samplecount >= 1968.0);
 
 % Baseline sample
    trainingSampleLength = length(1968.0:1/4:1982.75); %4*3;
 
 % Full sample
 %trainingSampleLength = 4;%length(1968.0:1/4:1982.75); %4*3;


 % Volker sample
 %trainingSampleLength = length(1968.0:1/4:1978); %4*3;

 
 % Great Moderation sample
%trainingSampleLength = length(1968.0:1/4:1983.75); %4*3;
 
 
 
 Y_pre = 0;
 startSample = 1968.0; %1980; 
 endSample = 2007.5;
 
 Y_main = Y_main(sampos,:);
 
 Y_main_all = Y_main_all(sampos,:);
 
 
      
%% OLD      
% [~,Y_pre,startSample, endSample,observableNames] = loadData(preSampleLength,startDate,endDate, vrbs_obs,nobs, dpath);

% use SmetsWouters original data
% startDate = 1959.25;
% SWData 
% 
% Y_main = SW_data(32:end,:); % start in 1965: this is as close as possible to the original estimation 

% use DGS original data

 
% load DGS
% 
% % load long-term expectations
% 
% 
% %if strcmp('SW', Mspec) 
% DGS_data(:,8) = NaN(size(DGS_data(:,8)));
% %end
% 
% Y_main = DGS_data(1:end-16,[1 5 6 7 9 10]); % ends 2008.5 % use observables' positions form the SW model spsc
% %Y_main = DGS_data(80:end-16,:); % 1984-2008.5


% OLD SCRIPT

% % time parameters (check excel source for sample information)
% startDate = 1964.0;
% endDate = 2008.5;
% trainingSampleLength = 0; % SW pre-sample from Dynare;
% preSampleLength = 0;
% 
% 
% % get indices for observables
% [vrbs_obs,nobs] = defineObservables();
% 
% [~,Y_pre,startSample, endSample,observableNames] = loadData(preSampleLength,startDate,endDate, vrbs_obs,nobs, dpath);
% 
% % use SmetsWouters original data
% % startDate = 1959.25;
% % SWData 
% % 
% % Y_main = SW_data(32:end,:); % start in 1965: this is as close as possible to the original estimation 
% 
% % use DGS original data
% 
% load DGS
% 
% if strcmp('SW', Mspec) 
% DGS_data(:,8) = NaN(size(DGS_data(:,8)));
% end
% 
% Y_main = DGS_data(1:end-16,:); % ends 2008.5
% %Y_main = DGS_data(80:end-16,:); % 1984-2008.5
% 
% 

