function [max_eig,eig_vec_0,eig_vec_c,flag_solve] = solveModel_stab(Mspec,params,params_index,vrbs,shocks,ModelDim,type,learning,Sml,c_gain) %#ok<INUSL>


flag_solve = 0;

   
% define rational expectations model

[A, B, C] = eval(['defineREModel',Mspec,'(vrbs,shocks,ModelDim,params,params_index)']);

% solve rational expectations model
[Br,Cr,Lr,NF,flag_reds] = redsf(A,B,C,ModelDim.nvar,ModelDim.nshock,ModelDim.nstate);

if flag_reds
T_Z = NaN; T_epsilon = NaN; D = NaN;F = NaN;G = NaN;H = NaN; flag_solve = 1; 
max_eig = NaN; eig_vec_0 = NaN; eig_vec_c = NaN; return   
else
[D,F,G,H,flag_solds] = soldsf(Br,Cr,Lr,ModelDim.nvar,ModelDim.nshock,ModelDim.nstate,NF);
end


if flag_solds
   T_Z = NaN; T_epsilon = NaN; D = NaN;F = NaN;G = NaN;H = NaN; flag_solve = 1;
   max_eig = NaN; eig_vec_0 = NaN; eig_vec_c = NaN; return     
else
D = real(D); F = real(F); G = real(G); H = real(H);
end



% Convert to VAR form
[Omega_Z, Omega_epsilon] = getVAR(D,F,G,H,vrbs,type); %#ok<NASGU>

    
    %[systemMats_full, lambda] = defineFullModelv1(vrbs,shocks,ModelDim,params,params_index);
   % [systemMats_full, lambda,K] = eval(['defineFullModel',Mspec,'(vrbs,shocks,ModelDim,params,params_index,Omega_Z, Omega_epsilon)']);
  [systemMats_full, lambda,K_mat,flagd] = eval(['defineFullModel',Mspec,'(vrbs,shocks,ModelDim,params,params_index,Omega_Z, Omega_epsilon)']); %#ok<ASGLU>
  
  if flagd
   T_Z = NaN; T_epsilon = NaN; D = NaN;F = NaN;G = NaN;H = NaN; flag_solve = 1; 
   max_eig = NaN; eig_vec_0 = NaN; eig_vec_c = NaN;return  
  end
    
%     [T_Z, T_epsilon, T_0,max_eig] = T_map(systemMats_full,Omega_Z, lambda,Sml,K,ModelDim.nestimated);
      [T_Z, T_epsilon, T_0,max_eig] = eval(['T_map',Mspec,'(systemMats_full,Omega_Z,lambda,Sml,K_mat,ModelDim.nestimated)']);

% Stability conditions

% gainv = 0.025;
% 
%     % Condition 1:
%     
%     eig_1 = eig(eye(size(T_0,1)) + gainv*(T_0-eye(size(T_0,1))));
%     
%     
%     eig_2 = eig(eye(size(Sml.Som,2)) + gainv*Sml.Som'*(T_0-eye(size(T_0,1)))*Sml.Som);
%     
%     %eig_3 = eig(eye(size(Sml.Som,2)) + gainv*Sml.Som'*((T_0-eye(size(T_0,1)))*(eye(size(Omega_Z,1))-Omega_Z))*Sml.Som);
%     
%     eig_3 = eig(eye(size(Sml.Som,2)) + gainv*Sml.Som'*((T_0-eye(size(T_0,1)))*(eye(size(Omega_Z,1))-T_Z))*Sml.Som);

AA{1} = zeros(size(Omega_Z,1));
AA{2} = zeros(size(Omega_Z));
disc = 1./lambda;

%AA{9} = systemMats_full.A7;
%AA{8} = systemMats_full.A6;
AA{7} = systemMats_full.A5;
AA{6} =systemMats_full.A4;
AA{5} = systemMats_full.A3;
AA{4} =systemMats_full.A2;
AA{3} = systemMats_full.A1;
CC = inv(systemMats_full.A0)*systemMats_full.A6;

%c_gain.cgainEstab = 1; c_gain.cgain = 0.006;

[~, ~, ~, T_c, T_Ls] = ALM_funv2(AA,CC,inv(systemMats_full.A0),Omega_Z,0,disc);

[eig_vec_0,eig_vec_c] = Estab_funv2(AA,inv(systemMats_full.A0),Omega_Z,T_c,T_Ls,0,disc,c_gain);
